package com.trs.example.check;

/**
 * <p>Title:        TRS WCM</p>
 * <p>Copyright:    Copyright (c) 2004</p>
 * <p>Company:      www.trs.com.cn</p>
 * @author			TRS WCM
 * @copyright		www.trs.com.cn
 * @created by		XWCMAutoTool 2.12
 * @version			5.2
 *
 * <p>Created:         2012/5/31 10:03:01</p>
 * <p>Last Modified:   2012/5/31 16:02:17</p>
 * <p>Description:
 *      class CheckInfo  CheckInfoĶʵ</p>
 * <p>Update Logs:
 *		[1] TRS WCM@2012/5/31 10:03:01 
 *		[2] 
 */

import com.trs.cms.auth.persistent.User;
import com.trs.cms.content.CMSObj;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.BaseObj;
import com.trs.infra.util.CMyDateTime;
import com.trs.infra.util.ExceptionNumber;

public class CheckInfo extends CMSObj {

    /** ͱ */
    public final static int OBJ_TYPE = 172762202;

    /** ݴ洢ݱ */
    public final static String DB_TABLE_NAME = "XWCMCHECKINFO";

    /** ݴ洢IDֶ */
    public final static String DB_ID_NAME = "CHECKINFOID";

    /** 캯ĬϽӿ */
    public CheckInfo() {
        super();
    }

    // ==============================================================================
    // ظеĳӿں

    /**
     * ȡݴ洢ݱ
     * 
     * @return ݴ洢ݱ
     */
    public String getDbTableName() {
        return DB_TABLE_NAME;
    }

    /**
     * ȡݴ洢IDֶ
     * 
     * @return IDֶ
     */
    public String getIdFieldName() {
        return DB_ID_NAME;
    }

    /**
     * ȡøöͱ
     * 
     * @return ͱ
     */
    public int getWCMType() {
        return OBJ_TYPE;
    }

    // ==============================================================================
    // Զд

    /**
     * ȡԣEmployerName
     * 
     * @return EmployerName
     */
    public String getEmployerName() {
        return this.getPropertyAsString("EMPLOYERNAME");
    }

    /**
     * ԣEmployerName
     * 
     * @param _sEmployerName
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setEmployerName(String _sEmployerName) throws WCMException {
        return this.setProperty("EMPLOYERNAME", _sEmployerName);
    }

    /**
     * ȡԣCheckInTime
     * 
     * @return CheckInTime
     */
    public CMyDateTime getCheckInTime() {
        return (CMyDateTime) this.getProperty("CHECKINTIME");
    }

    /**
     * ԣCheckInTime
     * 
     * @param _dtCheckInTime
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setCheckInTime(CMyDateTime _dtCheckInTime)
            throws WCMException {
        return this.setProperty("CHECKINTIME", _dtCheckInTime);
    }

    /**
     * ȡԣCheckOutTime
     * 
     * @return CheckOutTime
     */
    public CMyDateTime getCheckOutTime() {
        return (CMyDateTime) this.getProperty("CHECKOUTTIME");
    }

    /**
     * ԣCheckOutTime
     * 
     * @param _dtCheckOutTime
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setCheckOutTime(CMyDateTime _dtCheckOutTime)
            throws WCMException {
        return this.setProperty("CHECKOUTTIME", _dtCheckOutTime);
    }

    /**
     * ȡԣWorkTime
     * 
     * @return WorkTime
     */
    public int getWorkTime() {
        return this.getPropertyAsInt("WORKTIME", 0);
    }

    /**
     * ԣWorkTime
     * 
     * @param _nWorkTime
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setWorkTime(int _nWorkTime) throws WCMException {
        return this.setProperty("WORKTIME", _nWorkTime);
    }

    /**
     * ԣCrUser û ɸWCMObjṩӿ֧֡
     */

    /**
     * ԣCrTime ʱ ɸWCMObjṩӿ֧֡
     */

    // ==============================================================================
    // ݿ

    /**
     * Ч
     * 
     * @return Ч򷵻true򷵻false.
     * @throws WCMException
     *             òֵȷظ׳쳣
     */
    public boolean isValid() throws WCMException {
        if (isAddMode()) {
            // ǿǷ

            if (getProperty("EMPLOYERNAME") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "EmployerNameû(CheckInfo.isValid)");
            }
            if (getProperty("CHECKINTIME") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "CheckInTimeû(CheckInfo.isValid)");
            }
        } else { // ༭ģʽʱѾУ飡
            if (!this.isModified()) {
                throw new WCMException(
                        ExceptionNumber.ERR_PROPERTY_NOT_MODIFIED,
                        "ûи(CheckInfo.isValid)");
            }
        }// end if

        return true;
    }// END: isValid()

    /**
     * дݿ
     * 
     * @param _currUser
     *            ǰû
     * @throws WCMException
     *             дʧܣ׳쳣
     */
    public void insert(User _currUser) throws WCMException {
        if (isAddMode() && this.isModified()) {
            // Եȱʡֵ

            super.insert(_currUser); // insert into Db
        }// end if
    }

    // ==============================================================================
    // ߼

    /**
     * ȡָIDĶ
     * 
     * @param _nId
     *            ָĶID
     * @return ҵָIDĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static CheckInfo findById(int _nId) throws WCMException {
        // IDЧ
        if (_nId <= 0) {
            return null;
        }

        // ȡָIDĶ
        return (CheckInfo) BaseObj.findById(CheckInfo.class, _nId);

    }// END: findById()

    /**
     * ǰ[CheckInfo]ʵ
     * 
     * @return ǰʵ[CheckInfo]
     * @throws WCMException
     */
    public final static CheckInfo createNewInstance() throws WCMException {
        return (CheckInfo) BaseObj.createNewInstance(CheckInfo.class);
    }

    /**
     * ȡָKeyĶ
     * 
     * @param _oKey
     *            ָKey
     * @return ҵKeyĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static CheckInfo findByKey(Object _oKey) throws WCMException {
        return (CheckInfo) BaseObj.findByKey(CheckInfo.class, _oKey);
    }

}