package com.trs.example.flow.destroytask;

/**
 * <p>Title:        TRS WCM</p>
 * <p>Copyright:    Copyright (c) 2004</p>
 * <p>Company:      www.trs.com.cn</p>
 * @author			TRS WCM
 * @copyright		www.trs.com.cn
 * @created by		XWCMAutoTool 2.12
 * @version			5.2
 *
 * <p>Created:         2011/10/11 16:52:50</p>
 * <p>Last Modified:   2011/10/12 11:28:47</p>
 * <p>Description:
 *      class DestroyTask  DestroyTaskĶʵ</p>
 * <p>Update Logs:
 *		[1] TRS WCM@2011/10/11 16:52:50 
 *		[2] 
 */

import com.trs.cms.auth.persistent.User;
import com.trs.cms.content.CMSObj;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.BaseObj;
import com.trs.infra.util.ExceptionNumber;

public class DestroyTask extends CMSObj {

    /** ͱ */
    public final static int OBJ_TYPE = 1911367336;

    /** ݴ洢ݿ */
    public final static String DB_TABLE_NAME = "XWCMDESTROYTASK";

    /** ݴ洢IDֶ */
    public final static String DB_ID_NAME = "DESTROYTASKID";

    /** 캯ĬϽӿ */
    public DestroyTask() {
        super();
    }

    // ==============================================================================
    // ظеĳӿں

    /**
     * ȡݴ洢ݱ
     * 
     * @return ݴ洢ݱ
     */
    public String getDbTableName() {
        return DB_TABLE_NAME;
    }

    /**
     * ȡݴ洢IDֶ
     * 
     * @return IDֶ
     */
    public String getIdFieldName() {
        return DB_ID_NAME;
    }

    /**
     * ȡøöͱ
     * 
     * @return ͱ
     */
    public int getWCMType() {
        return OBJ_TYPE;
    }

    // ==============================================================================
    // Զд

    /**
     * ȡԣTitle
     * 
     * @return Title
     */
    public String getTitle() {
        return this.getPropertyAsString("DTITLE");
    }

    /**
     * ԣTitle
     * 
     * @param _sTitle
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setTitle(String _sTitle) throws WCMException {
        return this.setProperty("DTITLE", _sTitle);
    }

    /**
     * ȡԣDesc
     * 
     * @return Desc
     */
    public String getDesc() {
        return this.getPropertyAsString("DDESC");
    }

    /**
     * ԣDesc
     * 
     * @param _sDesc
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setDesc(String _sDesc) throws WCMException {
        return this.setProperty("DDESC", _sDesc);
    }

    public CMSObj getContent() throws WCMException {
        return (CMSObj) CMSObj.findById(getContentType(), getContentId());
    }

    /**
     * @param _nContentType
     * @param _nContentId
     * @return
     * @throws WCMException
     */
    public boolean setContent(int _nContentType, int _nContentId)
            throws WCMException {
        return setContentType(_nContentType) && setContentId(_nContentId);
    }

    /**
     * ȡԣContentType
     * 
     * @return ContentType
     */
    public int getContentType() {
        return this.getPropertyAsInt("CONTENTTYPE", 0);
    }

    /**
     * ԣContentType
     * 
     * @param _nContentType
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setContentType(int _nContentType) throws WCMException {
        return this.setProperty("CONTENTTYPE", _nContentType);
    }

    /**
     * ȡԣContentId
     * 
     * @return ContentId
     */
    public int getContentId() {
        return this.getPropertyAsInt("CONTENTID", 0);
    }

    /**
     * ԣContentId
     * 
     * @param _nContentId
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setContentId(int _nContentId) throws WCMException {
        return this.setProperty("CONTENTID", _nContentId);
    }

    /**
     * ȡԣCurrStep
     * 
     * @return CurrStep
     */
    public String getCurrStep() {
        return this.getPropertyAsString("DCURRSTEP");
    }

    /**
     * ԣCurrStep
     * 
     * @param _sCurrStep
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setCurrStep(String _sCurrStep) throws WCMException {
        return this.setProperty("DCURRSTEP", _sCurrStep);
    }

    /**
     * ȡԣFlowId
     * 
     * @return FlowId
     */
    public int getFlowId() {
        return this.getPropertyAsInt("FLOWID", 0);
    }

    /**
     * ԣFlowId
     * 
     * @param _nFlowId
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setFlowId(int _nFlowId) throws WCMException {
        return this.setProperty("FLOWID", _nFlowId);
    }

    /**
     * ԣCrUser û ɸWCMObjṩӿ֧֡
     */

    /**
     * ԣCrTime ʱ ɸWCMObjṩӿ֧֡
     */

    // ==============================================================================
    // ݿ

    /**
     * Ч
     * 
     * @return Ч򷵻true򷵻false.
     * @throws WCMException
     *             òֵȷظ׳쳣
     */
    public boolean isValid() throws WCMException {
        if (isAddMode()) {
            // ǿǷ

            if (getProperty("DTITLE") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "Titleû(DestroyTask.isValid)");
            }
            if (getProperty("DDESC") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "Descû(DestroyTask.isValid)");
            }
            if (getProperty("CONTENTTYPE") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "ContentTypeû(DestroyTask.isValid)");
            }
            if (getProperty("CONTENTID") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "ContentIdû(DestroyTask.isValid)");
            }
            if (getProperty("FLOWID") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "FlowIdû(DestroyTask.isValid)");
            }
        } else { // ༭ģʽʱѾУ飡
            if (!this.isModified()) {
                throw new WCMException(
                        ExceptionNumber.ERR_PROPERTY_NOT_MODIFIED,
                        "ûи(DestroyTask.isValid)");
            }
        }// end if

        return true;
    }// END: isValid()

    /**
     * дݿ
     * 
     * @param _currUser
     *            ǰû
     * @throws WCMException
     *             дʧܣ׳쳣
     */
    public void insert(User _currUser) throws WCMException {
        if (isAddMode() && this.isModified()) {
            // Եȱʡֵ

            super.insert(_currUser); // insert into Db
        }// end if
    }

    // ==============================================================================
    // ߼

    /**
     * ȡָIDĶ
     * 
     * @param _nId
     *            ָĶID
     * @return ҵָIDĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static DestroyTask findById(int _nId) throws WCMException {
        // IDЧ
        if (_nId <= 0) {
            return null;
        }

        // ȡָIDĶ
        return (DestroyTask) BaseObj.findById(DestroyTask.class, _nId);

    }// END: findById()

    /**
     * ǰ[DestroyTask]ʵ
     * 
     * @return ǰʵ[DestroyTask]
     * @throws WCMException
     */
    public final static DestroyTask createNewInstance() throws WCMException {
        return (DestroyTask) BaseObj.createNewInstance(DestroyTask.class);
    }

    /**
     * ȡָKeyĶ
     * 
     * @param _oKey
     *            ָKey
     * @return ҵKeyĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static DestroyTask findByKey(Object _oKey) throws WCMException {
        return (DestroyTask) BaseObj.findByKey(DestroyTask.class, _oKey);
    }

}