package com.trs.task;

/**
 * <p>Title:        TRS WCM</p>
 * <p>Copyright:    Copyright (c) 2004</p>
 * <p>Company:      www.trs.com.cn</p>
 * @author			TRS WCM
 * @copyright		www.trs.com.cn
 * @created by		XWCMAutoTool 2.12
 * @version			5.2
 *
 * <p>Created:         2010/12/22 11:25:31</p>
 * <p>Last Modified:   2010/12/22 11:28:21</p>
 * <p>Description:
 *      class TaskInfo  TaskInfoĶʵ</p>
 * <p>Update Logs:
 *		[1] TRS WCM@2010/12/22 11:25:31 
 *		[2] 
 */

import com.trs.cms.auth.persistent.User;
import com.trs.cms.content.CMSObj;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.BaseObj;
import com.trs.infra.util.ExceptionNumber;
import com.trs.infra.util.database.CDBText;

import com.trs.infra.util.*;
import com.trs.infra.util.database.*;

public class TaskInfo extends CMSObj{

    /** ͱ */
    public final static int     OBJ_TYPE      = 1338389866;

    /** ݴ洢ݿ */
    public final static String  DB_TABLE_NAME = "XWCMTASKINFO";

	/** ݴ洢IDֶ */
    public final static String  DB_ID_NAME    = "TASKINFOID";

    /** 캯ĬϽӿ */
    public TaskInfo(){
        super();
    }

//==============================================================================
//ظеĳӿں

    /**
     * ȡݴ洢ݱ
     * @return ݴ洢ݱ
     */
    public String getDbTableName(){
        return DB_TABLE_NAME;
    }

    /**
     * ȡݴ洢IDֶ
     * @return  IDֶ
     */
    public String getIdFieldName(){
        return DB_ID_NAME;
    }

    /**
     * ȡøöͱ
     * @return ͱ
     */
    public int getWCMType(){
        return OBJ_TYPE;
    }

//==============================================================================
//Զд


 /**
  * ȡԣName
   * @return  Name
   */
  public String getName(){
       return this.getPropertyAsString("TNAME");   
}

  /**
   * ԣName
   * @param	_sName ֵ
   * @return ֵָЧóɹ򷵻true򷵻false. 
   * @throws WCMException ֵЧʧܣ׳쳣
   */
  public boolean setName( String _sName ) throws WCMException{
      return this.setProperty("TNAME", _sName ); 
  }

 /**
  * ȡԣDesc
   * @return  Desc
   */
  public String getDesc(){
       return this.getPropertyAsString("TDESC");   
}

  /**
   * ԣDesc
   * @param	_sDesc ֵ
   * @return ֵָЧóɹ򷵻true򷵻false. 
   * @throws WCMException ֵЧʧܣ׳쳣
   */
  public boolean setDesc( String _sDesc ) throws WCMException{
      return this.setProperty("TDESC", _sDesc ); 
  }

 /**
  * ȡԣType
   * @return  Type
   */
  public int getType(){
       return this.getPropertyAsInt("TTYPE",0);   
}

  /**
   * ԣType
   * @param	_nType ֵ
   * @return ֵָЧóɹ򷵻true򷵻false. 
   * @throws WCMException ֵЧʧܣ׳쳣
   */
  public boolean setType( int _nType ) throws WCMException{
      return this.setProperty("TTYPE", _nType ); 
  }

  /** ԣCrUser  û
   *  ɸWCMObjṩӿ֧֡ 
   */

  /** ԣCrTime ʱ
   *  ɸWCMObjṩӿ֧֡ 
   */


//==============================================================================
//ݿ

    /**
     * Ч
     * @return Ч򷵻true򷵻false.
     * @throws WCMException  òֵȷظ׳쳣
     */
    public boolean isValid() throws WCMException{
        if( isAddMode() ){
			//ǿǷ
			
        }
        else{  //༭ģʽʱѾУ飡
            if( ! this.isModified()){
                throw new WCMException( ExceptionNumber.ERR_PROPERTY_NOT_MODIFIED,
					"ûи(TaskInfo.isValid)" );
            }
        }//end if

		return true;
    }//END: isValid()


    /**
     * дݿ
     * @param _currUser  ǰû
     * @throws WCMException  дʧܣ׳쳣
     */
    public void insert( User _currUser ) throws WCMException{
        if ( isAddMode() && this.isModified() ){
			//Եȱʡֵ
			


            super.insert( _currUser );  //insert into Db
        }//end if
    }

    //==============================================================================
    //߼

    /**
     * ȡָIDĶ
     * 
     * @param _nId
     *            ָĶID
     * @return ҵָIDĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static TaskInfo findById(int _nId) throws WCMException {
        //IDЧ
        if (_nId <= 0) {
            return null;
        }

        //ȡָIDĶ
        return (TaskInfo) BaseObj.findById(TaskInfo.class, _nId);

    }//END: findById()

    /**
     * ǰ[TaskInfo]ʵ
     * 
     * @return ǰʵ[TaskInfo]
     * @throws WCMException
     */
    public final static TaskInfo createNewInstance() throws WCMException {
        return (TaskInfo) BaseObj.createNewInstance(TaskInfo.class);
    }

    /**
     * ȡָKeyĶ
     * 
     * @param _oKey
     *            ָKey
     * @return ҵKeyĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static TaskInfo findByKey(Object _oKey) throws WCMException {
        return (TaskInfo) BaseObj.findByKey(TaskInfo.class, _oKey);
    }


}