package com.trs.xwcm.test;

/**
 * <p>Title:        TRS WCM</p>
 * <p>Copyright:    Copyright (c) 2004</p>
 * <p>Company:      www.trs.com.cn</p>
 * @author			TRS WCM Developer
 * @copyright		www.trs.com
 * @created by		XWCMAutoTool 2.12
 * @version			5.2
 *
 * <p>Created:         2010/12/18 13:58:25</p>
 * <p>Last Modified:   2010/12/18 13:59:32</p>
 * <p>Description:
 *      class Book  BookĶʵ</p>
 * <p>Update Logs:
 *		[1] TRS WCM Developer@2010/12/18 13:58:25 
 *		[2] 
 */

import com.trs.cms.auth.persistent.User;
import com.trs.cms.content.CMSObj;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.BaseObj;
import com.trs.infra.util.ExceptionNumber;
import com.trs.infra.util.database.CDBText;

import com.trs.infra.util.*;
import com.trs.infra.util.database.*;

public class Book extends CMSObj{

    /** ͱ */
    public final static int     OBJ_TYPE      = 1111893446;

    /** ݴ洢ݿ */
    public final static String  DB_TABLE_NAME = "XWCMBOOK";

	/** ݴ洢IDֶ */
    public final static String  DB_ID_NAME    = "BOOKID";

    /** 캯ĬϽӿ */
    public Book(){
        super();
    }

//==============================================================================
//ظеĳӿں

    /**
     * ȡݴ洢ݱ
     * @return ݴ洢ݱ
     */
    public String getDbTableName(){
        return DB_TABLE_NAME;
    }

    /**
     * ȡݴ洢IDֶ
     * @return  IDֶ
     */
    public String getIdFieldName(){
        return DB_ID_NAME;
    }

    /**
     * ȡøöͱ
     * @return ͱ
     */
    public int getWCMType(){
        return OBJ_TYPE;
    }

//==============================================================================
//Զд


 /**
  * ȡԣTitle
   * @return  Title
   */
  public String getTitle(){
       return this.getPropertyAsString("BTITLE");   
}

  /**
   * ԣTitle
   * @param	_sTitle ֵ
   * @return ֵָЧóɹ򷵻true򷵻false. 
   * @throws WCMException ֵЧʧܣ׳쳣
   */
  public boolean setTitle( String _sTitle ) throws WCMException{
      return this.setProperty("BTITLE", _sTitle ); 
  }

 /**
  * ȡԣDesc
   * @return  Desc
   */
  public String getDesc(){
       return this.getPropertyAsString("BDESC");   
}

  /**
   * ԣDesc
   * @param	_sDesc ֵ
   * @return ֵָЧóɹ򷵻true򷵻false. 
   * @throws WCMException ֵЧʧܣ׳쳣
   */
  public boolean setDesc( String _sDesc ) throws WCMException{
      return this.setProperty("BDESC", _sDesc ); 
  }

  /** ԣCrUser  û
   *  ɸWCMObjṩӿ֧֡ 
   */

  /** ԣCrTime ʱ
   *  ɸWCMObjṩӿ֧֡ 
   */


//==============================================================================
//ݿ

    /**
     * Ч
     * @return Ч򷵻true򷵻false.
     * @throws WCMException  òֵȷظ׳쳣
     */
    public boolean isValid() throws WCMException{
        if( isAddMode() ){
			//ǿǷ
			
 if( getProperty("BTITLE")==null ){ 
                 throw new WCMException( ExceptionNumber.ERR_PROPERTY_NOT_SET,"Titleû(Book.isValid)"); 
             }
        }
        else{  //༭ģʽʱѾУ飡
            if( ! this.isModified()){
                throw new WCMException( ExceptionNumber.ERR_PROPERTY_NOT_MODIFIED,
					"ûи(Book.isValid)" );
            }
        }//end if

		return true;
    }//END: isValid()


    /**
     * дݿ
     * @param _currUser  ǰû
     * @throws WCMException  дʧܣ׳쳣
     */
    public void insert( User _currUser ) throws WCMException{
        if ( isAddMode() && this.isModified() ){
			//Եȱʡֵ
			


            super.insert( _currUser );  //insert into Db
        }//end if
    }

    //==============================================================================
    //߼

    /**
     * ȡָIDĶ
     * 
     * @param _nId
     *            ָĶID
     * @return ҵָIDĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static Book findById(int _nId) throws WCMException {
        //IDЧ
        if (_nId <= 0) {
            return null;
        }

        //ȡָIDĶ
        return (Book) BaseObj.findById(Book.class, _nId);

    }//END: findById()

    /**
     * ǰ[Book]ʵ
     * 
     * @return ǰʵ[Book]
     * @throws WCMException
     */
    public final static Book createNewInstance() throws WCMException {
        return (Book) BaseObj.createNewInstance(Book.class);
    }

    /**
     * ȡָKeyĶ
     * 
     * @param _oKey
     *            ָKey
     * @return ҵKeyĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static Book findByKey(Object _oKey) throws WCMException {
        return (Book) BaseObj.findByKey(Book.class, _oKey);
    }


}