package com.trs.example;

import com.trs.DreamFactory;
import com.trs.TRSWCMBaseTest;
import com.trs.components.wcm.content.domain.DocumentMgr;
import com.trs.components.wcm.content.persistent.Channel;
import com.trs.components.wcm.content.persistent.Documents;
import com.trs.infra.util.CMyException;

public class WCMExampleForJUnitTest extends TRSWCMBaseTest {
    private static org.apache.log4j.Logger logger = org.apache.log4j.Logger
            .getLogger(WCMExampleForJUnitTest.class);

    public WCMExampleForJUnitTest(String name) {
        super(name);
    }

    public void testQueryDocuments() {
        try {
            // 1 ݲУݵЧ
            int nChannelId = 10;
            Channel channel = Channel.findById(nChannelId);
            assertNotNull("ָĿڣ[ĿID=" + nChannelId + "]", channel);

            // 2 ȡָĿĵ
            // 2.1 ȡĵҵ(ʷ룬Ŀǰ淶ӦIDocumentMgr)
            DocumentMgr oDocumentMgr = (DocumentMgr) DreamFactory
                    .createObjectById("DocumentMgr");
            // 2.2 ȡָĿĵжЧ
            Documents documents = oDocumentMgr.getDocuments(channel, null);
            assertTrue("صݲԤڣ", documents.size() >= 0);
        } catch (Exception ex) {
            logger.error("[testQueryDocuments]쳣", ex);
            fail("[testQueryDocuments]쳣\n"
                    + CMyException.getStackTraceText(ex));
        }
    }
}
