package com.trs.example.check;

import com.trs.DreamFactory;
import com.trs.TRSWCMBaseTest;
import com.trs.infra.persistent.WCMFilter;
import com.trs.infra.util.CMyException;

public class IEmployerMgrTest extends TRSWCMBaseTest {
    private static org.apache.log4j.Logger logger = org.apache.log4j.Logger
            .getLogger(IEmployerMgrTest.class);

    public IEmployerMgrTest(String name) {
        super(name);
    }

    public void testSave() {
        /*
         * 
         */
        try {
            // 1 ׼
            Employer employer = Employer.createNewInstance();
            employer.setEName("");
            employer.setEmail("zs@trs.com.cn");
            employer.setDepartment("Ʒ");

            // 2 
            IEmployerMgr oEmployerMgr = (IEmployerMgr) DreamFactory
                    .createObjectById("IEmployerMgr");
            oEmployerMgr.save(employer);

            // 3 УǷ񱣴ˣݶԵ
            Employer oNewEmployer = queryBy(employer);
            assertNotNull("ûбϣ", oNewEmployer);
        } catch (Exception ex) {
            logger.error("[testSave]쳣", ex);
            fail("[testSave]쳣\n" + CMyException.getStackTraceText(ex));
        }
    }

    public void testDelete() {
        fail("Not yet implemented");
    }

    public void testQuery() {
        fail("Not yet implemented");
    }

    private Employer queryBy(Employer _employer) throws Exception {
        // 1 һ
        WCMFilter filter = new WCMFilter("",
                "EName=? and Email=? and Department=?", "");
        filter.addSearchValues(_employer.getEName());
        filter.addSearchValues(_employer.getEmail());
        filter.addSearchValues(_employer.getDepartment());

        // 2 ݿвѯ
        Employers employers = Employers.openWCMObjs(null, filter);
        if (employers.isEmpty())
            return null;
        return (Employer) employers.getAt(0);
    }

}
