package com.trs.example.check;

/**
 * <p>Title:        TRS WCM</p>
 * <p>Copyright:    Copyright (c) 2004</p>
 * <p>Company:      www.trs.com.cn</p>
 * @author			TRS WCM
 * @copyright		www.trs.com.cn
 * @created by		XWCMAutoTool 2.12
 * @version			5.2
 *
 * <p>Created:         2012/5/31 13:16:40</p>
 * <p>Last Modified:   2012/5/31 13:20:52</p>
 * <p>Description:
 *      class Employer  EmployerĶʵ</p>
 * <p>Update Logs:
 *		[1] TRS WCM@2012/5/31 13:16:40 
 *		[2] 
 */

import com.trs.cms.auth.persistent.User;
import com.trs.cms.content.CMSObj;
import com.trs.infra.common.WCMException;
import com.trs.infra.persistent.BaseObj;
import com.trs.infra.util.CMyDateTime;
import com.trs.infra.util.ExceptionNumber;

public class Employer extends CMSObj {

    /** ͱ */
    public final static int OBJ_TYPE = 1595897109;

    /** ݴ洢ݱ */
    public final static String DB_TABLE_NAME = "XWCMEMPLOYER";

    /** ݴ洢IDֶ */
    public final static String DB_ID_NAME = "EMPLOYERID";

    /** 캯ĬϽӿ */
    public Employer() {
        super();
    }

    // ==============================================================================
    // ظеĳӿں

    /**
     * ȡݴ洢ݱ
     * 
     * @return ݴ洢ݱ
     */
    public String getDbTableName() {
        return DB_TABLE_NAME;
    }

    /**
     * ȡݴ洢IDֶ
     * 
     * @return IDֶ
     */
    public String getIdFieldName() {
        return DB_ID_NAME;
    }

    /**
     * ȡøöͱ
     * 
     * @return ͱ
     */
    public int getWCMType() {
        return OBJ_TYPE;
    }

    // ==============================================================================
    // Զд

    /**
     * ȡԣEName
     * 
     * @return EName
     */
    public String getEName() {
        return this.getPropertyAsString("ENAME");
    }

    /**
     * ԣEName
     * 
     * @param _sEName
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setEName(String _sEName) throws WCMException {
        return this.setProperty("ENAME", _sEName);
    }

    /**
     * ȡԣJoinDate
     * 
     * @return JoinDate
     */
    public CMyDateTime getJoinDate() {
        return (CMyDateTime) this.getProperty("JOINDATE");
    }

    /**
     * ԣJoinDate
     * 
     * @param _dtJoinDate
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setJoinDate(CMyDateTime _dtJoinDate) throws WCMException {
        return this.setProperty("JOINDATE", _dtJoinDate);
    }

    /**
     * ȡԣEmail
     * 
     * @return Email
     */
    public String getEmail() {
        return this.getPropertyAsString("EMAIL");
    }

    /**
     * ԣEmail
     * 
     * @param _sEmail
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setEmail(String _sEmail) throws WCMException {
        return this.setProperty("EMAIL", _sEmail);
    }

    /**
     * ȡԣDepartment
     * 
     * @return Department
     */
    public String getDepartment() {
        return this.getPropertyAsString("DEPARTMENT");
    }

    /**
     * ԣDepartment
     * 
     * @param _sDepartment
     *            ֵ
     * @return ֵָЧóɹ򷵻true򷵻false.
     * @throws WCMException
     *             ֵЧʧܣ׳쳣
     */
    public boolean setDepartment(String _sDepartment) throws WCMException {
        return this.setProperty("DEPARTMENT", _sDepartment);
    }

    /**
     * ԣCrUser û ɸWCMObjṩӿ֧֡
     */

    /**
     * ԣCrTime ʱ ɸWCMObjṩӿ֧֡
     */

    // ==============================================================================
    // ݿ

    /**
     * Ч
     * 
     * @return Ч򷵻true򷵻false.
     * @throws WCMException
     *             òֵȷظ׳쳣
     */
    public boolean isValid() throws WCMException {
        if (isAddMode()) {
            // ǿǷ

            if (getProperty("ENAME") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "ENameû(Employer.isValid)");
            }
            if (getProperty("JOINDATE") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "JoinDateû(Employer.isValid)");
            }
            if (getProperty("EMAIL") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "Emailû(Employer.isValid)");
            }
            if (getProperty("DEPARTMENT") == null) {
                throw new WCMException(ExceptionNumber.ERR_PROPERTY_NOT_SET,
                        "Departmentû(Employer.isValid)");
            }
        } else { // ༭ģʽʱѾУ飡
            if (!this.isModified()) {
                throw new WCMException(
                        ExceptionNumber.ERR_PROPERTY_NOT_MODIFIED,
                        "ûи(Employer.isValid)");
            }
        }// end if

        return true;
    }// END: isValid()

    /**
     * дݿ
     * 
     * @param _currUser
     *            ǰû
     * @throws WCMException
     *             дʧܣ׳쳣
     */
    public void insert(User _currUser) throws WCMException {
        if (isAddMode() && this.isModified()) {
            // Եȱʡֵ

            super.insert(_currUser); // insert into Db
        }// end if
    }

    // ==============================================================================
    // ߼

    /**
     * ȡָIDĶ
     * 
     * @param _nId
     *            ָĶID
     * @return ҵָIDĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static Employer findById(int _nId) throws WCMException {
        // IDЧ
        if (_nId <= 0) {
            return null;
        }

        // ȡָIDĶ
        return (Employer) BaseObj.findById(Employer.class, _nId);

    }// END: findById()

    /**
     * ǰ[Employer]ʵ
     * 
     * @return ǰʵ[Employer]
     * @throws WCMException
     */
    public final static Employer createNewInstance() throws WCMException {
        return (Employer) BaseObj.createNewInstance(Employer.class);
    }

    /**
     * ȡָKeyĶ
     * 
     * @param _oKey
     *            ָKey
     * @return ҵKeyĶ򷵻ضʵ壻򣬷null
     * @throws WCMException
     *             ȡʧܣ׳쳣
     */
    public final static Employer findByKey(Object _oKey) throws WCMException {
        return (Employer) BaseObj.findByKey(Employer.class, _oKey);
    }

}